/****************************************************************************
 ** ScStw Styling
 ** Copyright (C) 2020  Itsblue development
 **
 ** This program is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ****************************************************************************/

#ifndef APPTHEME_H
#define APPTHEME_H

#include <QObject>
#include <QVariant>
#include <QFontDatabase>

class ScStwAppTheme : public QObject
{
    Q_OBJECT
    Q_PROPERTY(QVariant colors READ getColors NOTIFY colorsChanged)
    Q_PROPERTY(QVariant icons READ getIcons NOTIFY iconsChanged)
    Q_PROPERTY(QVariant fonts READ getFonts NOTIFY fontsChanged)
    Q_PROPERTY(QVariant images READ getImages NOTIFY imagesChanged)


public:
    explicit ScStwAppTheme(QString name, QVariantMap colors = {}, QVariantMap icons = {}, QVariantMap fonts = {}, QVariantMap images = {}, QObject *parent = nullptr);

private:
    QString name;
    QVariantMap colors;
    QVariantMap icons;
    QVariantMap fonts;
    QVariantMap images;

signals:
    void colorsChanged();
    void iconsChanged();
    void fontsChanged();
    void imagesChanged();


public slots:
    QString getName();
    QVariant getColors();
    QVariant getIcons();
    QVariant getFonts();
    QVariant getImages();
};


#endif // APPTHEME_H
